﻿using System;
using System.Data;
using System.Drawing;
using TBarCodeBarcodeGeneration.DataSet1TableAdapters;

namespace TBarCodeBarcodeGeneration {
  class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Start Inserting");
            insertIntoDB();
            Console.WriteLine("Press [Enter] to exit.");
            Console.ReadLine();

        }
            //Code for generating bar code of type Code128
            static public Byte[] GenerateBarcodeStream(String data){
                TECIT.TBarCode.Barcode barcode = new TECIT.TBarCode.Barcode();
                barcode.BarcodeType = TECIT.TBarCode.BarcodeType.Code128;
                barcode.Data = data;
                barcode.Font = new System.Drawing.Font("Arial", 10f);
                barcode.Dpi = 100;
                Size optimalSize = barcode.CalculateOptimalBitmapSize(null, 1, 1);
                barcode.BoundingRectangle = new Rectangle(0, 0, optimalSize.Width, 60 /* 60px */);

                using (System.IO.MemoryStream ms = new System.IO.MemoryStream()){
                    Bitmap bitmap = barcode.DrawBitmap();
                    bitmap.Save(ms, System.Drawing.Imaging.ImageFormat.Gif);
                    ms.Position = 0;
                    return ms.ToArray();
                }
            }

        //Code for generating bar code of type Data Matrix
        static public Byte[] GenerateBarcodeStream2D(String data)
            {
                TECIT.TBarCode.Barcode barcode = new TECIT.TBarCode.Barcode();
                barcode.BarcodeType = TECIT.TBarCode.BarcodeType.DataMatrix;
                barcode.Data = data;
                barcode.Dpi = 100;
                Size optimalSize = barcode.CalculateOptimalBitmapSize(null, 2, 2);
                barcode.BoundingRectangle = new Rectangle(0, 0, optimalSize.Width,
                  optimalSize.Height);

                using (System.IO.MemoryStream ms = new System.IO.MemoryStream())
                {
                    Bitmap bitmap = barcode.DrawBitmap();
                    bitmap.Save(ms, System.Drawing.Imaging.ImageFormat.Gif);
                    /*
                    // or save as 24 bit JPG
                    ImageCodecInfo jpgCodec = ImageCodecInfo.GetImageEncoders().Where(codec =>
                                   codec.FormatID.Equals(ImageFormat.Jpeg.Guid)).FirstOrDefault();
                    System.Drawing.Imaging.EncoderParameters parameters = new 
                                   System.Drawing.Imaging.EncoderParameters();
                    parameters.Param[0] = new EncoderParameter 
                                   (System.Drawing.Imaging.Encoder.ColorDepth, 24);
                    bitmap.Save(ms, jpgCodec, parameters);
                    */
                    ms.Position = 0;
                    return ms.ToArray();
                }
            }

        static public void insertIntoDB()
        {
            //initializeis filds
            tblBarcodesTableAdapter tableAdapterBar = new tblBarcodesTableAdapter(); //adapter for bar code table
            EmployeesTableAdapter tableAdapterEmp = new EmployeesTableAdapter(); //adapter fpr employees table
            DataSet1 dataSet = new DataSet1();
            DataSet1.EmployeesDataTable empData = tableAdapterEmp.GetData(); //select rows from Employees
            tableAdapterBar.DeleteQuery(); //delete all entryes in bar code table

            foreach (DataRow empRow in empData)
            {
                if (empRow["EmployeeID"] != null)
                {
                    string myData = empRow["LastName"].ToString().Trim(); //LastName is used as data source for bar code generation
                    try
                    {               
                        Byte[] barcodeImageStream = GenerateBarcodeStream2D(myData); //generate bar code  Data Matrix
                        Byte[] barcodeImageStream2 = GenerateBarcodeStream(myData); //generate bar code  Code128
                        //insert images into bar code table
                        int ret = tableAdapterBar.Insert(barcodeImageStream, Convert.ToBase64String(barcodeImageStream2), myData);
                        dataSet.tblBarcodes.AcceptChanges();
                        Console.WriteLine("Barcode " + myData + " inserted! Returnvalue= " + ret);
                    }
                    catch (Exception ex)
                    {
                        // error in bar code generation (invalid data?)
                    }
                }
            }
        }
    }
}
